//------------------------------------------------------------------------
// File name...............: TabOpera.cpp
// Programmr..............: Bjrk Boye Busch
// Beskrivelse.............: Eksempler p definition og brug af funktions
//							 og operator overload p tabeller
//------------------------------------------------------------------------

#include "TabOpera.h"

//-----------------------------------------------------------------------------------------
// Constructors, assignment og destructors
//-----------------------------------------------------------------------------------------

CxTab::CxTab ()							// default constuctor
{
	AntalElm = 10;
	for (int i = 0; i < AntalElm; i++)
		DataTab[i] = i;
}


CxTab::CxTab (const CxTab& Tabi)		// copy constructor
{
	if (this != &Tabi)
	{
		for (int i = 0; i < Tabi.AntalElm; i++)
			DataTab[i] = Tabi.DataTab[i];
	}
}

CxTab& CxTab::operator= (const CxTab& Tab2)	// CxTab = CxTab	assign
{
	if (this != &Tab2)
	{
		for (int i = 0; i < Tab2.AntalElm; i++)
			DataTab[i] = Tab2.DataTab[i];
	}
	return (*this);
}


CxTab::~CxTab ()						// destuctor
{
	// algoritme for nedlggelse (oprydning)
	// ved brug af dynamiske data (oprettet med new) frigres med delete
	// bemrk at der ogs kan laves operateroverload p new og delete
}


//-----------------------------------------------------------------------------------------
// index operatorer
//-----------------------------------------------------------------------------------------
int& CxTab::operator[] (int i)		// CxTab[int]	member index
{
	return (DataTab[i]);
}


//-----------------------------------------------------------------------------------------
// cin og cout
//-----------------------------------------------------------------------------------------

void CxTab::Out(ostream& os)
{
AntalElm = 10;
	for (int i = 0; i < AntalElm; i++)
		os << DataTab[i] << "\n";
}

ostream& operator<< (ostream& os, CxTab Tab)
{
	Tab.Out(os);
	return (os);
}

void CxTab::In(istream& is)		// public hjlpefunktion
{
	is >> DataTab[AntalElm++];
}

istream& operator>> (istream& is, CxTab& Tab)
{
	Tab.In(is);
	return (is);
}

